extern crate proc_macro;
#[macro_use] extern crate quote;
extern crate syn;

use syn::*;

#[proc_macro_derive(GetFields)]
pub fn get_fields_derive(input: proc_macro::TokenStream) -> proc_macro::TokenStream {
    let item: DeriveInput = parse_derive_input(&input.to_string()).unwrap();

    let fields = match item.body {
        Body::Struct(ref data) => data.fields().clone(),
        Body::Enum(_) => panic!("Structs only")
    };

    let field_names: Vec<String> =
        fields.into_iter().map(|f| format!("{}", f.ident.clone().unwrap())).collect();

    let name = item.ident;

    (quote! {
        impl GetFields for #name {
            fn get_fields() -> Vec<String> {
                #field_names.into_iter().map(|s| s.to_string()).collect()
            }
        }
    }).parse().unwrap()
}
